/*
 *@file:can_apply.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <net/if.h>
#include "can_apply.h"

int can_recv(int sock, struct can_frame *frame)
{
	int nbytes;

	nbytes = read(sock, frame, sizeof(struct can_frame));
	if(nbytes)
	{
		;//printf("[can_recv]dlc = %d, nbytes = %d\n", frame->can_dlc, nbytes);
	}

	return nbytes;
}

int can_send(int sock, struct can_frame frame)
{
	int nbytes;
	int wlen = sizeof(struct can_frame);
	int times = 2;

	while(times --) 
	{
	    nbytes = write(sock, &frame, wlen);
	    if (nbytes != wlen)
	    {
	    	printf("Send Error frame(nbytes:%d, wlen:%d)\n", nbytes, wlen);
			usleep(200);
	        continue;
	    }
	    else
	    {
	    	//printf("Send frame(nbytes:%d, wlen:%d)\n", nbytes, wlen);
	        return (0);
	    }
	}

	return -1;
}

int can_open(char *can_name)
{
	struct ifreq ifr;
    struct sockaddr_can addr;
	int sock;
	int ret = -1;
	int loopback = 0;
//	struct can_filter rfilter[1];
	
    /* open socket */
    sock = socket(PF_CAN, SOCK_RAW, CAN_RAW);
    if(sock < 0)
    {
        return ret;
    }
	
    strcpy(ifr.ifr_name, can_name);
    if (ioctl(sock, SIOCGIFINDEX, &ifr) < 0)
    {
        goto err_can_open;
    }
	addr.can_family = AF_CAN;
    addr.can_ifindex = ifr.ifr_ifindex;
  //  fcntl(sock, F_SETFL, O_NONBLOCK);
    if (bind(sock, (struct sockaddr *)&addr, sizeof(addr)) < 0)
    {
        goto err_can_open;
    }

	//close loopback
	setsockopt(sock, SOL_CAN_RAW, CAN_RAW_LOOPBACK, &loopback, sizeof(loopback));
/*
	rfilter[0].can_id = 0x12;
	rfilter[0].can_mask = CAN_SFF_MASK;
	setsockopt(sock, SOL_CAN_RAW, CAN_RAW_FILTER, &rfilter, sizeof(rfilter));
*/
	return sock;

err_can_open:
	close(sock);	
    return ret;
}

